; #########################################################################

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include SDI.inc       ; local includes for this file

.code

; #########################################################################

start:

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance, $invoke (GetModuleHandle, NULL)      
      mov hCursor, $invoke (LoadCursor,NULL,IDC_ARROW)
      call Main
      invoke ExitProcess,eax

; #########################################################################

Main proc

    STRING szClassMain,"SDI_MENU_XX"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassMain,
                       NULL,hCursor,COLOR_BTNFACE+1
 
  ; -------------------------------------------------
    mov hMenu, $invoke ( LoadMenuA , hInstance, MAINMENU)
    mov hContextMenu, $invoke (GetSubMenu, hMenu, 1)   ; get handle menu context
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,
                          ADDR szClassMain,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT,0,CW_USEDEFAULT,0,
                          NULL,hMenu,
                          hInstance,NULL
    mov hWnd,eax

    invoke ShowWindow,hWnd, SW_SHOWNORMAL 
    invoke UpdateWindow,hWnd

    mov h_Accel, $invoke (LoadAccelerators, hInstance, ACC)

    call MsgLoop
    ret

Main endp

; #########################################################################

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; ########################################################################

MsgLoop proc

  ; ------------------------------------------
  ; The following 4 equates are available for
  ; processing messages directly in the loop.
  ; m_hWnd - m_Msg - m_wParam - m_lParam
  ; ------------------------------------------

    LOCAL msg:MSG

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateAccelerator, hWnd, h_Accel, ADDR msg
      cmp eax, 0
      jne StartLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp short StartLoop
    ExitLoop:

    mov eax, msg.wParam
    ret

MsgLoop endp

; #########################################################################

WndProc proc hWin :HWND, uMsg :UINT, wParam :WPARAM, lParam :LPARAM

    LOCAL StyleMenu	  :DWORD
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    LOCAL hBmpImgList :HBITMAP
    LOCAL imageinfo   :IMAGEINFO
    
    WM_CASE uMsg, <CREATE, COMMAND, CONTEXTMENU, DESTROY, SYSCOMMAND>     

@@end:    
    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret
    
@@CREATE: 

    ; create Image List
    mov hImageList, $invoke (ImageList_Create, 16, 16, ILC_COLOR or ILC_MASK, 20,0)
    mov hBmpImgList, $invoke (LoadBitmap, hInstance, IDB_BITMAP1)
    RGB 192, 192, 192
    invoke ImageList_AddMasked, hImageList, hBmpImgList, eax
    invoke DeleteObject, hBmpImgList

    invoke RedrawMenu, hWin, hMenu, STYLE_OFFICE_XP     ; Redraw Menu
    invoke SetMenuItemIcon, hMenu, IDM_FILE_NEW, $invoke (ImageList_GetIcon, hImageList, 0, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_FILE_OPEN, $invoke (ImageList_GetIcon, hImageList, 1, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_FILE_SAVE, $invoke (ImageList_GetIcon, hImageList, 2, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_FILE_PRINT, $invoke (ImageList_GetIcon, hImageList, 3, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_FILE_PRINT_PREVIEW,  $invoke (ImageList_GetIcon, hImageList, 4, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_FILE_PRINT_SETUP, $invoke (ImageList_GetIcon, hImageList, 5, ILD_NORMAL) 

    invoke SetMenuItemIcon, hMenu, IDM_EDIT_UNDO, $invoke (ImageList_GetIcon, hImageList, 6, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_EDIT_CUT, $invoke (ImageList_GetIcon, hImageList, 7, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_EDIT_COPY, $invoke (ImageList_GetIcon, hImageList, 8, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_EDIT_PASTE, $invoke (ImageList_GetIcon,  hImageList, 9, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_EDIT_DELETE, $invoke (ImageList_GetIcon, hImageList, 10, ILD_NORMAL)
    invoke SetMenuItemIcon, hMenu, IDM_VIEW_TOOLBARS_CUSTOMIZE, $invoke (ImageList_GetIcon, hImageList, 11, ILD_NORMAL) 
    invoke SetMenuItemIcon, hMenu, IDM_HELP_ABOUT_MENU_XX,  $invoke (ImageList_GetIcon, hImageList, 12, ILD_NORMAL)

    ; Radio item in menu, for style
    invoke CheckMenuRadioItem, hMenu, IDM_VIEW_STYLE_DEFAULT, IDM_VIEW_STYLE_OFFICE_XP, IDM_VIEW_STYLE_OFFICE_XP, MF_BYCOMMAND

    ; system menu
    mov hSysMenu, $invoke ( GetSystemMenu, hWin, FALSE )   ; get handle system menu
    invoke AppendMenu, hSysMenu, MF_SEPARATOR, 0, 0        ; append separator
    ; Append Item "About"
    invoke GetMenuString, hMenu, IDM_HELP_ABOUT_MENU_XX, ADDR buffer1, 128, MF_BYCOMMAND    ; get string item About in main menu
    invoke AppendMenu, hSysMenu, MF_STRING, IDM_HELP_ABOUT_MENU_XX, ADDR buffer1    
    invoke RedrawMenu, hWin, hSysMenu, STYLE_OFFICE_XP     ; Redraw system menu
    ; Set icon for item "About", for system menu
    invoke SetMenuItemIcon, hSysMenu, IDM_HELP_ABOUT_MENU_XX, $invoke (ImageList_GetIcon, hImageList, 12, ILD_NORMAL)   

    jmp @@end
@@COMMAND:

    ;======== menu commands ========
    mov eax, wParam
    
        .if ax == IDM_FILE_APP_EXIT
        
            invoke	SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
        
        .elseif ax == IDM_VIEW_TOOLBARS_STANDARD
              
            jmp reverse                     
        .elseif ax == IDM_VIEW_TOOLBARS_CUSTOMIZE
             
        .elseif ax == IDM_VIEW_SATATUSBAR
        
reverse:        
            invoke GetMenuState, hMenu, wParam, MF_BYCOMMAND            
            and eax, MF_CHECKED
            
            .if eax == MF_CHECKED
                invoke CheckMenuItem,hMenu, wParam, MF_BYCOMMAND or MF_UNCHECKED                        
            .else                           
                invoke CheckMenuItem,hMenu, wParam, MF_BYCOMMAND or MF_CHECKED             
            .endif
            
        .elseif ax == IDM_VIEW_STYLE_DEFAULT
            mov StyleMenu, STYLE_DEFAULT                        
            jmp radio_check
            
        .elseif ax == IDM_VIEW_STYLE_OFFICE_2000
            mov StyleMenu, STYLE_OFFICE_2000
            jmp radio_check
             
        .elseif ax == IDM_VIEW_STYLE_OFFICE_XP
            mov StyleMenu, STYLE_OFFICE_XP
     
radio_check:
	  invoke RedrawMenu, hWin, hMenu, StyleMenu
            invoke RedrawMenu, hWin, hSysMenu, StyleMenu
            invoke CheckMenuRadioItem, hMenu, IDM_VIEW_STYLE_DEFAULT, IDM_VIEW_STYLE_OFFICE_XP, wParam, MF_BYCOMMAND                                        

        .elseif ax == IDM_HELP_ABOUT_MENU_XX        ; About

            invoke DialogBoxParamA, hInstance, IDD_ABOUT, hWin, AboutProc, NULL
            
        .else

            invoke GetMenuString, hMenu, wParam, ADDR buffer1, 128, MF_BYCOMMAND
            invoke dwtoa, DWORD PTR [wParam], ADDR buffer2 
            invoke MessageBox, hWin, ADDR buffer1, ADDR buffer2, MB_OK
        .endif
        
    ;====== end menu commands ======
        jmp @@end
@@CONTEXTMENU:
        push 0
        push hWin        
        push 0        
        HIWORD lParam   ; vert
        push eax
        LOWORD lParam   ; horiz
        push eax
        push 0
        push hContextMenu
        call TrackPopupMenu

        jmp @@end

@@SYSCOMMAND:        

        mov eax, wParam    
        .if ax == IDM_HELP_ABOUT_MENU_XX        ; About
            invoke DialogBoxParamA, hInstance, IDD_ABOUT, hWin, AboutProc, NULL            
        .endif
        
        jmp @@end                

@@DESTROY:    
        invoke ImageList_Destroy, hImageList
        invoke PostQuitMessage,NULL
        return 0

WndProc endp

; ########################################################################
; About
; ########################################################################

AboutProc proc hDlg :HWND, uMsg :UINT, wParam :WPARAM, lParam :LPARAM

    LOCAL ps    :PAINTSTRUCT
    LOCAL Rct   :RECT
    
   .if  (uMsg == WM_COMMAND && wParam == IDOK) || uMsg == WM_CLOSE
    
        invoke EndDialog, hDlg, 0
        return TRUE
        
   .elseif uMsg == WM_PAINT
   
      invoke BeginPaint,hDlg,ADDR ps
      invoke GetClientRect,hDlg,ADDR Rct
      invoke DrawEdge,ps.hdc,ADDR Rct,EDGE_ETCHED,BF_RECT
      invoke EndPaint,hDlg,ADDR ps
                      
   .endif
    
    xor eax, eax    
    ret
    
AboutProc endp

; ########################################################################

end start
